
*---Analysis of overdispersed proportions using %glimmix;
*---Out of date (see demo_GLIMMIX(treatment proportions)_using_PROC.sas 
	for use of new PROC GLIMMIX (for two of the models).;

/* Example of analysis of Phomopsis leaf blight for 1997		*/
/* using %GLIMMIX macro 										*/
/* trt: treatment; rep: block; su: sampling unit within plot;	*/
/* x: number of diseased leaflets; n: leaflet number			*/
/* 

/* The original article (Madden et al. 2002. PLANT DISEASE, 	*/
/* Vol. 86, pages 316-325) is based solely on the now 			*/
/* out of date %glimmix macro. With one exception, the new 		*/
/* procedure can do all the model fits, plus much more			*/

/* Read in data... Data strung across lines						*/

data phomop;
input trt rep su x n @@;
datalines;
 8 1 1   4  15  8 1 2  12  15  8 1 3  11  15  8 1 4  12  15 
 8 1 5   9  15  1 2 1   9  15  1 2 2   4  15  1 2 3   3  15 
 1 2 4   9  15  1 2 5   7  15  2 3 1   3  15  2 3 2   9  15 
 2 3 3   4  15  2 3 4   4  15  2 3 5   6  15  7 4 1   4  15 
 7 4 2   0  15  7 4 3   1  15  7 4 4   2  15  7 4 5   0  15 
 6 1 1   2  15  6 1 2   2  15  6 1 3   1  15  6 1 4   0  15 
 6 1 5   6  15  3 2 1   1  15  3 2 2   1  15  3 2 3   1  15 
 3 2 4   0  15  3 2 5   2  15  5 3 1   0  15  5 3 2   1  15 
 5 3 3   1  15  5 3 4   0  15  5 3 5   0  15  8 4 1   6  15 
 8 4 2   1  15  8 4 3   9  15  8 4 4   4  15  8 4 5   8  15 
 4 1 1   5  15  4 1 2   7  15  4 1 3   5  15  4 1 4   0  15 
 4 1 5   5  15  5 2 1   0  15  5 2 2   0  15  5 2 3   0  15 
 5 2 4   1  15  5 2 5   0  15  8 3 1  12  15  8 3 2   5  15 
 8 3 3   6  15  8 3 4   9  15  8 3 5   5  15  1 4 1   6  15 
 1 4 2  11  15  1 4 3   1  15  1 4 4   2  15  1 4 5   6  15 
 1 1 1   0  15  1 1 2   7  15  1 1 3   0  15  1 1 4   2  15 
 1 1 5   4  15  8 2 1   9  15  8 2 2   7  15  8 2 3   6  15 
 8 2 4   0  15  8 2 5   4  15  6 3 1   1  15  6 3 2   0  15 
 6 3 3   0  15  6 3 4   0  15  6 3 5   1  15  4 4 1   1  15 
 4 4 2   0  15  4 4 3   0  15  4 4 4   0  15  4 4 5   0  15 
 3 1 1   4  15  3 1 2   4  15  3 1 3   0  15  3 1 4   6  15 
 3 1 5   5  15  4 2 1   5  15  4 2 2   3  15  4 2 3   3  15 
 4 2 4   3  15  4 2 5   0  15  3 3 1   3  15  3 3 2   0  15 
 3 3 3   0  15  3 3 4   3  15  3 3 5   8  15  6 4 1   0  15 
 6 4 2   0  15  6 4 3   2  15  6 4 4   1  15  6 4 5   2  15 
 2 1 1   0  15  2 1 2   5  15  2 1 3   1  15  2 1 4   0  15 
 2 1 5   6  15  2 2 1   6  15  2 2 2   2  15  2 2 3   0  15 
 2 2 4   6  15  2 2 5   7  15  7 3 1   0  15  7 3 2   0  15 
 7 3 3   0  15  7 3 4   0  15  7 3 5   0  15  5 4 1   0  15 
 5 4 2   1  15  5 4 3   2  15  5 4 4   0  15  5 4 5   1  15 
 5 1 1   0  15  5 1 2   1  15  5 1 3   1  15  5 1 4   1  15 
 5 1 5   0  15  6 2 1   0  15  6 2 2   3  15  6 2 3   2  15 
 6 2 4   1  15  6 2 5   1  15  4 3 1   1  15  4 3 2   6  15 
 4 3 3   0  15  4 3 4   0  15  4 3 5   1  15  3 4 1   0  15 
 3 4 2   0  15  3 4 3   2  15  3 4 4   3  15  3 4 5   1  15 
 7 1 1   0  15  7 1 2   0  15  7 1 3   0  15  7 1 4   0  15 
 7 1 5   0  15  7 2 1   1  15  7 2 2   1  15  7 2 3   0  15 
 7 2 4   0  15  7 2 5   0  15  1 3 1   3  15  1 3 2   5  15 
 1 3 3   7  15  1 3 4   2  15  1 3 5   1  15  2 4 1   1  15 
 2 4 2   0  15  2 4 3   8  15  2 4 4   5  15  2 4 5  11  15 
;
/* The following statement tells SAS where to find %glimmix	*/
/* (you may have it in a different directory)			*/
/* Note: the macro may have several examples attached.	*/
/* Remove these examples and re-save the macro.		*/


%INCLUDE 'C:\users\madden.1\My Documents\My SAS Files\glimmix.sas';

/* Model A					*/
/* See Piepho (1999) for a nice description of the SAS input.	*/
/* in addition to the REPL analysis, least squares means	*/
/* (estimated linear predictors) for TRT are calculated, as well 	*/
/* as pairwise differences (PDIFF)			*/
/* Note: COVTEST does a large-sample test for all estimated	*/
/* variance terms (probably not valid with typical sample sized)	*/

%glimmix(data =phomop, procopt=covtest,
		stmts=%str(title 'MODEL A, 1997';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		random rep;
		random int / sub=trt*rep;
               		lsmeans trt / cl pdiff;
		),
	error=binomial, maxit=50,
	link=logit
); 

/* Model B					*/
/* Need to specifiy initial estimates of variances in PARMS for:	*/
/* rep, rep*trt,  sampling error, and residual (phi). 		*/
/* Four variances in total.  The last one is equated to 1 here	*/
/* (with the EQCONS option)				*/

%glimmix(data =phomop, procopt=covtest,
		stmts=%str(title 'MODEL B, 1997';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		random rep;
		random int su/ sub=trt*rep;
		parms (0.04) (0.03) (0.4) (1) /eqcons=4;
               		 lsmeans trt / cl pdiff;
		
		),
	error=binomial, maxit=50,
	link=logit
); 

/* Model C					*/
/* The REPEATED statement is used to define the residual 	*/
/* variance (not needed in A, because there one is using the	*/ 
/* default of a single phi).				*/
/* Only needed when there are special conditions.		*/

%glimmix(data =phomop, procopt=covtest,
		stmts=%str(title 'MODEL C, 1997';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		random rep;
		random int / sub=trt*rep;
		repeated su / sub=rep group=trt;
               		 lsmeans trt / cl pdiff;
		
		),
	error=binomial, maxit=50,
	link=logit
); 

/* Next run is just to get predicted p_i's  without random effects;	*/
/* use as first step in 2-step estimation of local phi (residual)	*/   
/* otherwise, ignore output				*/
/* data file is created (results) to be used in the next sted	*/

%glimmix(data =phomop, procopt=covtest,
		stmts=%str(title 'first step to get p_hats for later analysis';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		             
		),
	error=binomial,
	link=logit, 
	out=results
); 

/* Create needed variable (PQT) from above output		*/
/* to use as input for Model D, below			*/
/* (in convention of glimmix, mu is p_hat, and _wght is weight	*/

data phomop2;
	set results;
	pqt=log(mu*(1-mu)/_wght);


/* Model D					*/
/* Use original data and the predicted mu's (p_hats) from	*/
/* a fixed-effects-only model				*/
/* See the REPEATED with LOCAL option for the		*/
/* binary power-law					*/
/*Note: overdispersion scale (phi) is A of the binary power-law.	*/
/* Thus, this calculated scale has no physical meaning at all	*/
/* (because b' and p_hat must be considered).		*/

%glimmix(data =phomop2, procopt=covtest,
		stmts=%str(title 'MODEL D, 1997 (uses REPEATED/LOCAL option)';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		random rep;
		random int / sub=trt*rep;
		repeated / local = exp(pqt);
                	lsmeans trt / cl pdiff;
		
		),
	error=binomial,
	link=logit,  maxit=50
	
); 

/* Model E					*/
/* One must change the PARMS statement to match the	*/
/* number of  variance terms. One needs (in this order):	*/
/* an initial estimate for rep, rep*trt, variance for each  	*/
/*  treatment level, and then the residual phi (=1).		*/
/* With 1997, there are 8 treatment levels, so one specifies	*/
/* 1+1+8+1 = 11 variance estimates.			*/
/* One also must indicate that the last term is always 1.	*/ 

%glimmix(data =phomop, procopt=covtest,
		stmts=%str(title 'MODEL E, 1997';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		random rep;
		random int / sub=trt*rep;
		random su / sub=rep group=trt;
		parms (0.01) (0.6) (.1) (.1) (.1) (.1) (.1) 
			(.1) (.1) (.1) (1) /eqcons=11;
               		 lsmeans trt / cl pdiff;
		
		),
	error=binomial, maxit=50,
	link=logit
); 

run;	 	
		
*---Because the rep variance is estimated as 0, it is probably best to 
	take out the rep term from the random statement.;



